## libglibutil 1.0.79

=== test/Makefile ===
# -*- Mode: makefile-gmake -*-

all:
%:
	@$(MAKE) -C test_datapack $*
	@$(MAKE) -C test_history $*
	@$(MAKE) -C test_idlepool $*
	@$(MAKE) -C test_idlequeue $*
	@$(MAKE) -C test_inotify $*
	@$(MAKE) -C test_intarray $*
	@$(MAKE) -C test_ints $*
	@$(MAKE) -C test_log $*
	@$(MAKE) -C test_misc $*
	@$(MAKE) -C test_objv $*
	@$(MAKE) -C test_ring $*
	@$(MAKE) -C test_strv $*
	@$(MAKE) -C test_weakref $*

=== test/test_datapack/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_datapack

include ../common/Makefile

=== test/test_idlepool/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_idlepool

include ../common/Makefile

=== test/test_inotify/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_inotify

include ../common/Makefile

=== test/test_intarray/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_intarray

include ../common/Makefile

=== test/test_ints/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_ints

include ../common/Makefile

=== test/test_ring/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_ring

include ../common/Makefile

=== test/test_strv/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_strv

include ../common/Makefile

=== debian/changelog ===
libglibutil (1.0.79) unstable; urgency=low

  * Exported gutil_source_remove() and Added gutil_source_clear()

 -- Slava Monich <slava@monich.com>  Thu, 02 May 2024 17:40:30 +0300

libglibutil (1.0.78) unstable; urgency=low

  * Added gutil_source_remove()
  * Added gutil_source_clear()

 -- Slava Monich <slava@monich.com>  Thu, 02 May 2024 04:43:18 +0300

libglibutil (1.0.77) unstable; urgency=low

  * Eliminate defects found by Coverity

 -- Slava Monich <slava@monich.com>  Wed, 10 Apr 2024 04:13:16 +0300

libglibutil (1.0.76) unstable; urgency=low

  * Added gutil_idle_pool_get_default()
  * Return the value pushed to the idle pool
  * Interpret NULL as the default pool when appropriate

 -- Slava Monich <slava@monich.com>  Sun, 28 Jan 2024 02:36:16 +0200

libglibutil (1.0.75) unstable; urgency=low

  * Cross-compilation tweaks
  * Compatibility with clang -fsanitize=cfi
  * Export all and only required symbols

 -- Slava Monich <slava@monich.com>  Fri, 01 Dec 2023 02:01:34 +0200

libglibutil (1.0.74) unstable; urgency=low

  * Added Added gutil_data_copy_as_variant()

 -- Slava Monich <slava@monich.com>  Sun, 10 Sep 2023 04:11:17 +0300

libglibutil (1.0.73) unstable; urgency=low

  * Define and use MAKE var instead of explicitly calling make
  * Added gutil_log_set_timestamp_format()

 -- Slava Monich <slava@monich.com>  Tue, 05 Sep 2023 15:53:55 +0300

libglibutil (1.0.72) unstable; urgency=low

  * Don't export gutil_time_notify_get_type()
  * Added gutil_data_new()
  * Added gutil_data_copy()
  * Added gutil_objv_new()

 -- Slava Monich <slava@monich.com>  Sun, 20 Aug 2023 02:05:13 +0300

libglibutil (1.0.71) unstable; urgency=low

  * Added gutil_object_ref()
  * Added gutil_object_unref()
  * Added gutil_objv_append()
  * Added gutil_objv_insert()
  * Added gutil_ptrv_is_empty()
  * Added gutil_bin2hex()
  * Added gutil_data2hex()

 -- Slava Monich <slava@monich.com>  Sun, 18 Jun 2023 14:24:13 +0300

libglibutil (1.0.70) unstable; urgency=low

  * Added gutil_objv module

 -- Slava Monich <slava@monich.com>  Mon, 29 May 2023 01:35:08 +0300

libglibutil (1.0.69) unstable; urgency=low

  * Runtime and compile time version detection
  * Added gutil_datapack module
  * Require glib 2.32

 -- Slava Monich <slava@monich.com>  Thu, 06 Apr 2023 02:13:48 +0300

libglibutil (1.0.68) unstable; urgency=low

  * Added gutil_weakref module
  * Fixed a few compilation warnings
  * Packaging tweaks

 -- Slava Monich <slava@monich.com>  Sat, 04 Feb 2023 04:26:45 +0200

libglibutil (1.0.67) unstable; urgency=low

  * Added gutil_log_dump_bytes()

 -- Slava Monich <slava.monich@jolla.com>  Fri, 15 Jul 2022 03:02:33 +0300

libglibutil (1.0.66) unstable; urgency=low

  * Bumped debhelper compat level to 7

 -- Slava Monich <slava.monich@jolla.com>  Fri, 15 Jul 2022 03:02:33 +0300

libglibutil (1.0.65) unstable; urgency=low

  * Fixed a Musl compatibility issue

 -- Slava Monich <slava.monich@jolla.com>  Thu, 16 Jun 2022 02:12:22 +0300

libglibutil (1.0.64) unstable; urgency=low

  * Resolved a mysterious parallel build issue

 -- Slava Monich <slava.monich@jolla.com>  Tue, 17 May 2022 03:56:50 +0300

libglibutil (1.0.63) unstable; urgency=low

  * Added gutil_bytes_has_prefix()
  * Added gutil_bytes_has_suffix()

 -- Slava Monich <slava.monich@jolla.com>  Sat, 23 Apr 2022 21:24:25 +0300

libglibutil (1.0.62) unstable; urgency=low

  * Added gutil_strlen0()
  * Added gutil_strv_find_last()
  * Added gutil_strv_remove_dups()

 -- Slava Monich <slava.monich@jolla.com>  Sun, 13 Mar 2022 21:59:26 +0200

libglibutil (1.0.61) unstable; urgency=low

  * Added gutil_strv_remove()

 -- Slava Monich <slava.monich@jolla.com>  Thu, 25 Nov 2021 18:31:18 +0200

libglibutil (1.0.60) unstable; urgency=low

  * Housekeeping release

 -- Slava Monich <slava.monich@jolla.com>  Mon, 22 Nov 2021 23:37:14 +0200

libglibutil (1.0.58) unstable; urgency=low

  * Don't check upper bound when setting log level from the envvironment

 -- Slava Monich <slava.monich@jolla.com>  Wed, 17 Nov 2021 13:17:45 +0200

libglibutil (1.0.57) unstable; urgency=low

  * Fixed unit tests for older 32-bit systems

 -- Slava Monich <slava.monich@jolla.com>  Mon, 08 Nov 2021 02:28:37 +0200

libglibutil (1.0.56) unstable; urgency=low

  * Added gutil_parse_int64()
  * Added gutil_parse_uint64()

 -- Slava Monich <slava.monich@jolla.com>  Sun, 03 Oct 2021 20:18:15 +0300

libglibutil (1.0.55) unstable; urgency=low

  * Added gutil_log_dump()
  * Added gutil_range_init_with_bytes()
  * Added gutil_range_has_prefix()
  * Added gutil_range_skip_prefix()

 -- Slava Monich <slava.monich@jolla.com>  Sun, 23 May 2021 03:33:58 +0300

libglibutil (1.0.54) unstable; urgency=low

  * Added GUtilRange type
  * Tweaked interpretation of environment variables

 -- Slava Monich <slava.monich@jolla.com>  Mon, 17 May 2021 16:06:25 +0300

libglibutil (1.0.53) unstable; urgency=low

  * Optimized gutil_parse_int()
  * Added gutil_parse_uint()

 -- Slava Monich <slava.monich@jolla.com>  Wed, 05 May 2021 15:30:57 +0300

libglibutil (1.0.52) unstable; urgency=low

  * Added gutil_memdup()

 -- Slava Monich <slava.monich@jolla.com>  Sun, 18 Apr 2021 17:40:41 +0300

libglibutil (1.0.51) unstable; urgency=low

  * Initialize default log settings from the environment
  * Disable timestamps by default
  * Added gutil_log_tid option
  * Added gutil_ptrv_free()

 -- Slava Monich <slava.monich@jolla.com>  Thu, 25 Feb 2021 19:36:05 +0200

libglibutil (1.0.50) unstable; urgency=low

  * Added gutil_ptrv_length()

 -- Slava Monich <slava.monich@jolla.com>  Wed, 28 Oct 2020 17:59:10 +0200

libglibutil (1.0.49) unstable; urgency=low

  * Added gutil_slice_free() macro

 -- Slava Monich <slava.monich@jolla.com>  Sat, 17 Oct 2020 01:01:25 +0300

libglibutil (1.0.48) unstable; urgency=low

  * Make library executable on rpm based systems

 -- Slava Monich <slava.monich@jolla.com>  Mon, 31 Aug 2020 00:07:18 +0300

libglibutil (1.0.47) unstable; urgency=low

  * Added gutil_strv_addv()



=== debian/control ===
Source: libglibutil
Section: libs
Priority: optional
Maintainer: Slava Monich <slava.monich@jolla.com>
Build-Depends: debhelper (>= 8.1.3), libglib2.0-dev (>= 2.32)
Standards-Version: 3.8.4

Package: libglibutil
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library of glib utilities

Package: libglibutil-dev
Section: libdevel
Architecture: any
Depends: libglibutil (= ${binary:Version}), ${misc:Depends}
Description: Development files for libglibutil

## libglibutil 1.0.80

=== Makefile ===
# -*- Mode: makefile-gmake -*-

.PHONY: clean all debug release coverage pkgconfig install install-dev test
.PHONY: print_debug_lib print_release_lib print_coverage_lib
#
# Required packages
#

PKGS = glib-2.0 gobject-2.0

#
# Default target
#

all: debug release pkgconfig

#
# Directories
#

SRC_DIR = src
INCLUDE_DIR = include
BUILD_DIR = build
DEBUG_BUILD_DIR = $(BUILD_DIR)/debug
RELEASE_BUILD_DIR = $(BUILD_DIR)/release
COVERAGE_BUILD_DIR = $(BUILD_DIR)/coverage

#
# Library version
#

VERSION_FILE = $(INCLUDE_DIR)/gutil_version.h
get_version = $(shell grep -E '^ *\#define +GUTIL_VERSION_$1 +[0-9]+$$' $(VERSION_FILE) | sed 's/  */ /g' | cut -d ' ' -f 3)

VERSION_MAJOR := $(call get_version,MAJOR)
VERSION_MINOR := $(call get_version,MINOR)
VERSION_MICRO := $(call get_version,MICRO)

# Version for pkg-config
PCVERSION := $(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_MICRO)

#
# Library name
#

NAME = glibutil
LIB_NAME = lib$(NAME)
LIB_DEV_SYMLINK = $(LIB_NAME).so
LIB_SYMLINK1 = $(LIB_DEV_SYMLINK).$(VERSION_MAJOR)
LIB_SYMLINK2 = $(LIB_SYMLINK1).$(VERSION_MINOR)
LIB_SONAME = $(LIB_SYMLINK1)
LIB = $(LIB_SONAME).$(VERSION_MINOR).$(VERSION_MICRO)
STATIC_LIB = $(LIB_NAME).a

#
# Sources
#

SRC = \
  gutil_datapack.c \
  gutil_history.c \
  gutil_idlepool.c \
  gutil_idlequeue.c \
  gutil_inotify.c \
  gutil_intarray.c \
  gutil_ints.c \
  gutil_log.c \
  gutil_misc.c \
  gutil_ring.c \
  gutil_strv.c \
  gutil_timenotify.c \
  gutil_objv.c \
  gutil_version.c \
  gutil_weakref.c

#
# Tools and flags
#

PKG_CONFIG ?= pkg-config
CC ?= $(CROSS_COMPILE)gcc
STRIP ?= strip
LD = $(CC)
WARNINGS ?= -Wall -Wsign-compare
INCLUDES = -I$(INCLUDE_DIR)
BASE_FLAGS = -fPIC
FULL_CFLAGS = $(BASE_FLAGS) $(CFLAGS) $(DEFINES) $(WARNINGS) $(INCLUDES) \
  -DGLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_32 \
  -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_MAX_ALLOWED \
  -MMD -MP $(shell $(PKG_CONFIG) --cflags $(PKGS))
FULL_LDFLAGS = $(BASE_FLAGS) $(LDFLAGS) -shared -Wl,-soname,$(LIB_SONAME) \
  -Wl,--version-script=$(LIB_NAME).ver
LIBS := $(shell $(PKG_CONFIG) --libs $(PKGS))
DEBUG_FLAGS = -g
RELEASE_FLAGS =
COVERAGE_FLAGS = -g

KEEP_SYMBOLS ?= 0
ifneq ($(KEEP_SYMBOLS),0)
RELEASE_FLAGS += -g
endif

DEBUG_LDFLAGS = $(FULL_LDFLAGS) $(DEBUG_FLAGS)
RELEASE_LDFLAGS = $(FULL_LDFLAGS) $(RELEASE_FLAGS)
DEBUG_CFLAGS = $(FULL_CFLAGS) $(DEBUG_FLAGS) -DDEBUG
RELEASE_CFLAGS = $(FULL_CFLAGS) $(RELEASE_FLAGS) -O2
COVERAGE_CFLAGS = $(FULL_CFLAGS) $(COVERAGE_FLAGS) -O0 --coverage

#
# Files
#

PKGCONFIG = $(BUILD_DIR)/$(LIB_NAME).pc
DEBUG_OBJS = $(SRC:%.c=$(DEBUG_BUILD_DIR)/%.o)
RELEASE_OBJS = $(SRC:%.c=$(RELEASE_BUILD_DIR)/%.o)
COVERAGE_OBJS = $(SRC:%.c=$(COVERAGE_BUILD_DIR)/%.o)

DEBUG_LIB = $(DEBUG_BUILD_DIR)/$(LIB)
RELEASE_LIB = $(RELEASE_BUILD_DIR)/$(LIB)
DEBUG_LINK = $(DEBUG_BUILD_DIR)/$(LIB_SYMLINK1)
RELEASE_LINK = $(RELEASE_BUILD_DIR)/$(LIB_SYMLINK1)
DEBUG_DEV_LINK = $(DEBUG_BUILD_DIR)/$(LIB_DEV_SYMLINK)
RELEASE_DEV_LINK = $(RELEASE_BUILD_DIR)/$(LIB_DEV_SYMLINK)
DEBUG_STATIC_LIB = $(DEBUG_BUILD_DIR)/$(STATIC_LIB)
RELEASE_STATIC_LIB = $(RELEASE_BUILD_DIR)/$(STATIC_LIB)
COVERAGE_STATIC_LIB = $(COVERAGE_BUILD_DIR)/$(STATIC_LIB)

#
# Dependencies
#

DEPS = $(DEBUG_OBJS:%.o=%.d) $(RELEASE_OBJS:%.o=%.d) $(COVERAGE_OBJS:%.o=%.d)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(DEPS)),)
-include $(DEPS)
endif
endif

$(PKGCONFIG): | $(BUILD_DIR)
$(DEBUG_OBJS) $(DEBUG_LIB) $(DEBUG_STATIC_LIB): | $(DEBUG_BUILD_DIR)
$(RELEASE_OBJS) $(RELEASE_LIB) $(RELEASE_STATIC_LIB): | $(RELEASE_BUILD_DIR)
$(COVERAGE_OBJS) $(COVERAGE_STATIC_LIB): | $(COVERAGE_BUILD_DIR)

#
# Rules
#

debug: $(DEBUG_STATIC_LIB) $(DEBUG_DEV_LINK)

release: $(RELEASE_STATIC_LIB) $(RELEASE_DEV_LINK)

coverage: $(COVERAGE_STATIC_LIB)

pkgconfig: $(PKGCONFIG)

print_debug_lib:
	@echo $(DEBUG_STATIC_LIB)

print_release_lib:
	@echo $(RELEASE_STATIC_LIB)

print_coverage_lib:
	@echo $(COVERAGE_STATIC_LIB)

clean:
	$(MAKE) -C test clean
	rm -fr test/coverage/results test/coverage/*.gcov
	rm -f *~ $(SRC_DIR)/*~ $(INCLUDE_DIR)/*~
	rm -fr $(BUILD_DIR) RPMS installroot
	rm -fr debian/tmp debian/libglibutil debian/libglibutil-dev
	rm -f documentation.list debian/files debian/*.substvars
	rm -f debian/*.debhelper.log debian/*.debhelper debian/*~
	rm -fr debian/*.install

test:
	$(MAKE) -C test test

$(BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR):
	mkdir -p $@

$(RELEASE_BUILD_DIR):
	mkdir -p $@

$(COVERAGE_BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(COVERAGE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(COVERAGE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_LIB): $(DEBUG_OBJS)
	$(LD) $(DEBUG_OBJS) $(DEBUG_LDFLAGS) -o $@ $(LIBS)

$(RELEASE_LIB): $(RELEASE_OBJS)
	$(LD) $(RELEASE_OBJS) $(RELEASE_LDFLAGS) -o $@ $(LIBS)
ifeq ($(KEEP_SYMBOLS),0)
	$(STRIP) $@
endif

$(DEBUG_LINK): $(DEBUG_LIB)
	ln -sf $(LIB) $@

$(RELEASE_LINK): $(RELEASE_LIB)
	ln -sf $(LIB) $@

$(DEBUG_DEV_LINK): $(DEBUG_LINK)
	ln -sf $(LIB_SYMLINK1) $@

$(RELEASE_DEV_LINK): $(RELEASE_LINK)
	ln -sf $(LIB_SYMLINK1) $@

$(DEBUG_STATIC_LIB): $(DEBUG_OBJS)
	$(AR) rc $@ $?

$(RELEASE_STATIC_LIB): $(RELEASE_OBJS)
	$(AR) rc $@ $?

$(COVERAGE_STATIC_LIB): $(COVERAGE_OBJS)
	$(AR) rc $@ $?

#
# LIBDIR usually gets substituted with arch specific dir.
# It's relative in deb build and can be whatever in rpm build.
#

LIBDIR ?= usr/lib
ABS_LIBDIR := $(shell echo /$(LIBDIR) | sed -r 's|/+|/|g')

$(PKGCONFIG): $(LIB_NAME).pc.in Makefile
	sed -e 's|@version@|$(PCVERSION)|g' -e 's|@libdir@|$(ABS_LIBDIR)|g' $< > $@

debian/%.install: debian/%.install.in
	sed 's|@LIBDIR@|$(LIBDIR)|g' $< > $@

#
# Install
#

INSTALL_PERM  = 644

INSTALL = install
INSTALL_DIRS = $(INSTALL) -d
INSTALL_FILES = $(INSTALL) -m $(INSTALL_PERM)

INSTALL_LIB_DIR = $(DESTDIR)$(ABS_LIBDIR)
INSTALL_INCLUDE_DIR = $(DESTDIR)/usr/include/gutil
INSTALL_PKGCONFIG_DIR = $(DESTDIR)$(ABS_LIBDIR)/pkgconfig

#
# rpm based systems expect libraries to be 755
# deb based systems expect libraries to be 644
#
# 755 works for both because dh_fixperms removes execute permissions
# from any libraries and other files that don't need it.
#
install: $(INSTALL_LIB_DIR)
	$(INSTALL) -m 755 $(RELEASE_LIB) $(INSTALL_LIB_DIR)
	ln -sf $(LIB) $(INSTALL_LIB_DIR)/$(LIB_SYMLINK2)
	ln -sf $(LIB_SYMLINK2) $(INSTALL_LIB_DIR)/$(LIB_SYMLINK1)

install-dev: install $(INSTALL_INCLUDE_DIR) $(INSTALL_PKGCONFIG_DIR)
	$(INSTALL_FILES) $(INCLUDE_DIR)/*.h $(INSTALL_INCLUDE_DIR)
	$(INSTALL_FILES) $(PKGCONFIG) $(INSTALL_PKGCONFIG_DIR)
	ln -sf $(LIB_SYMLINK1) $(INSTALL_LIB_DIR)/$(LIB_DEV_SYMLINK)

$(INSTALL_LIB_DIR):
	$(INSTALL_DIRS) $@

$(INSTALL_INCLUDE_DIR):
	$(INSTALL_DIRS) $@

$(INSTALL_PKGCONFIG_DIR):
	$(INSTALL_DIRS) $@

=== test/common/Makefile ===
# -*- Mode: makefile-gmake -*-

.PHONY: clean all debug release coverage debug_lib release_lib coverage_lib

#
# Real test makefile defines EXE (and possibly SRC) and includes this one.
#

ifndef EXE
${error EXE not defined}
endif

SRC ?= $(EXE).c
COMMON_SRC ?= test_main.c test_object.c

#
# Required packages
#

PKGS += gobject-2.0 glib-2.0

#
# Default target
#

all: debug release

#
# Directories
#

SRC_DIR = .
LIB_DIR = ../..
COMMON_DIR = ../common
BUILD_DIR = build
DEBUG_BUILD_DIR = $(BUILD_DIR)/debug
RELEASE_BUILD_DIR = $(BUILD_DIR)/release
COVERAGE_BUILD_DIR = $(BUILD_DIR)/coverage

#
# Tools and flags
#

PKG_CONFIG ?= pkg-config
CC ?= $(CROSS_COMPILE)gcc
LD = $(CC)
WARNINGS = -Wall
INCLUDES = -I$(LIB_DIR)/include -I$(LIB_DIR)/src -I$(COMMON_DIR)
BASE_FLAGS = -fPIC
BASE_LDFLAGS = $(BASE_FLAGS) $(LDFLAGS)
BASE_CFLAGS = $(BASE_FLAGS) $(CFLAGS)
FULL_CFLAGS = $(BASE_CFLAGS) $(DEFINES) $(WARNINGS) $(INCLUDES) -MMD -MP \
  -DGLIB_VERSION_MAX_ALLOWED=GLIB_VERSION_2_32 \
  -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_MAX_ALLOWED \
  $(shell $(PKG_CONFIG) --cflags $(PKGS))
FULL_LDFLAGS = $(BASE_LDFLAGS)
LIBS = $(shell $(PKG_CONFIG) --libs $(PKGS))
QUIET_MAKE = $(MAKE) --no-print-directory
DEBUG_FLAGS = -g
RELEASE_FLAGS =
COVERAGE_FLAGS = -g

KEEP_SYMBOLS ?= 0
ifneq ($(KEEP_SYMBOLS),0)
RELEASE_FLAGS += -g
SUBMAKE_OPTS += KEEP_SYMBOLS=1
endif

DEBUG_LDFLAGS = $(FULL_LDFLAGS) $(DEBUG_FLAGS)
RELEASE_LDFLAGS = $(FULL_LDFLAGS) $(RELEASE_FLAGS)
COVERAGE_LDFLAGS = $(FULL_LDFLAGS) $(COVERAGE_FLAGS) --coverage

DEBUG_CFLAGS = $(FULL_CFLAGS) $(DEBUG_FLAGS) -DDEBUG
RELEASE_CFLAGS = $(FULL_CFLAGS) $(RELEASE_FLAGS) -O2
COVERAGE_CFLAGS = $(FULL_CFLAGS) $(COVERAGE_FLAGS) --coverage

#
# Files
#

DEBUG_OBJS = \
  $(COMMON_SRC:%.c=$(DEBUG_BUILD_DIR)/common_%.o) \
  $(SRC:%.c=$(DEBUG_BUILD_DIR)/%.o)
RELEASE_OBJS = \
  $(COMMON_SRC:%.c=$(RELEASE_BUILD_DIR)/common_%.o) \
  $(SRC:%.c=$(RELEASE_BUILD_DIR)/%.o)
COVERAGE_OBJS = \
  $(COMMON_SRC:%.c=$(COVERAGE_BUILD_DIR)/common_%.o) \
  $(SRC:%.c=$(COVERAGE_BUILD_DIR)/%.o)

DEBUG_LIB_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_debug_lib)
RELEASE_LIB_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_release_lib)
COVERAGE_LIB_FILE := $(shell $(QUIET_MAKE) -C $(LIB_DIR) print_coverage_lib)

DEBUG_LIB := $(LIB_DIR)/$(DEBUG_LIB_FILE)
RELEASE_LIB := $(LIB_DIR)/$(RELEASE_LIB_FILE)
COVERAGE_LIB := $(LIB_DIR)/$(COVERAGE_LIB_FILE)

#
# Dependencies
#

DEPS = $(DEBUG_OBJS:%.o=%.d) $(RELEASE_OBJS:%.o=%.d) $(COVERAGE_OBJS:%.o=%.d)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(DEPS)),)
-include $(DEPS)
endif
endif

$(DEBUG_LIB): | debug_lib
$(RELEASE_LIB): | release_lib
$(COVERAGE_LIB): | coverage_lib

$(DEBUG_OBJS): | $(DEBUG_BUILD_DIR)
$(RELEASE_OBJS): | $(RELEASE_BUILD_DIR)
$(COVERAGE_OBJS): | $(COVERAGE_BUILD_DIR)

#
# Rules
#

DEBUG_EXE = $(DEBUG_BUILD_DIR)/$(EXE)
RELEASE_EXE = $(RELEASE_BUILD_DIR)/$(EXE)
COVERAGE_EXE = $(COVERAGE_BUILD_DIR)/$(EXE)

debug: debug_lib $(DEBUG_EXE)

release: release_lib $(RELEASE_EXE)

coverage: coverage_lib $(COVERAGE_EXE)

clean:
	rm -f *~
	rm -fr $(BUILD_DIR)

cleaner: clean
	@$(MAKE) -C $(LIB_DIR) clean

test_banner:
	@echo "===========" $(EXE) "=========== "

test: test_banner debug 
	@$(DEBUG_EXE)

valgrind: test_banner debug
	@G_DEBUG=gc-friendly G_SLICE=always-malloc valgrind --tool=memcheck --leak-check=full --show-possibly-lost=no $(DEBUG_EXE)

$(DEBUG_BUILD_DIR):
	mkdir -p $@

$(RELEASE_BUILD_DIR):
	mkdir -p $@

$(COVERAGE_BUILD_DIR):
	mkdir -p $@

$(DEBUG_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(COVERAGE_BUILD_DIR)/%.o : $(SRC_DIR)/%.c
	$(CC) -c $(COVERAGE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_BUILD_DIR)/common_%.o : $(COMMON_DIR)/%.c
	$(CC) -c $(DEBUG_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(RELEASE_BUILD_DIR)/common_%.o : $(COMMON_DIR)/%.c
	$(CC) -c $(RELEASE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(COVERAGE_BUILD_DIR)/common_%.o : $(COMMON_DIR)/%.c
	$(CC) -c $(COVERAGE_CFLAGS) -MT"$@" -MF"$(@:%.o=%.d)" $< -o $@

$(DEBUG_EXE): $(DEBUG_LIB) $(DEBUG_BUILD_DIR) $(DEBUG_OBJS)
	$(LD) $(DEBUG_LDFLAGS) $(DEBUG_OBJS) $< $(LIBS) -o $@

$(RELEASE_EXE): $(RELEASE_LIB) $(RELEASE_BUILD_DIR) $(RELEASE_OBJS)
	$(LD) $(RELEASE_LDFLAGS) $(RELEASE_OBJS) $< $(LIBS) -o $@
ifeq ($(KEEP_SYMBOLS),0)
	strip $@
endif

$(COVERAGE_EXE): $(COVERAGE_LIB) $(COVERAGE_BUILD_DIR) $(COVERAGE_OBJS)
	$(LD) $(COVERAGE_LDFLAGS) $(COVERAGE_OBJS) $< $(LIBS) -o $@

debug_lib:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) debug

release_lib:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) release

coverage_lib:
	@$(MAKE) $(SUBMAKE_OPTS) -C $(LIB_DIR) coverage

=== test/test_history/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_history

include ../common/Makefile

=== test/test_idlequeue/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_idlequeue

include ../common/Makefile

=== test/test_log/Makefile ===
# -*- Mode: makefile-gmake -*-

CFLAGS += -DGLOG_LEVEL_MAX=GLOG_LEVEL_VERBOSE -DGLOG_LEVEL_ASSERT=GLOG_LEVEL_ALWAYS
EXE = test_log

include ../common/Makefile

=== test/test_misc/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_misc

include ../common/Makefile

=== test/test_objv/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_objv

include ../common/Makefile

=== test/test_weakref/Makefile ===
# -*- Mode: makefile-gmake -*-

EXE = test_weakref

include ../common/Makefile

=== debian/changelog ===
libglibutil (1.0.80-0pureos1) crimson; urgency=medium

  * New upstream release
  * d/control: Bump glib dependency to 2.32
  * d/patches: Revert "Define and use MAKE var instead of explicitly calling make"

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Tue, 21 Oct 2025 17:44:40 +0200

libglibutil (1.0.67-0pureos1) byzantium; urgency=medium

  * Upload to byzantium

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 07 Nov 2022 22:33:56 +0100

=== debian/control ===
Source: libglibutil
Section: libs
Priority: optional
Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
XSBC-Original-Maintainer: Slava Monich <slava.monich@jolla.com>
Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.32)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/sailfishos/libglibutil
Vcs-Browser: https://source.puri.sm/Librem5/debs/libglibutil
Vcs-Git: https://source.puri.sm/Librem5/debs/libglibutil.git

Package: libglibutil1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libglibutil
Breaks: libglibutil
Description: Library of glib utilities
 Utilities for GLib written for SailfishOS development.

Package: libglibutil-dev
Section: libdevel
Architecture: any
Depends: libglibutil1 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libglibutil
 Utilities for GLib written for SailfishOS development.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

LIBDIR=usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_build:
	dh_auto_build -- LIBDIR=$(LIBDIR) release pkgconfig debian/libglibutil1.install debian/libglibutil-dev.install

override_dh_auto_install:
	dh_auto_install -- LIBDIR=$(LIBDIR) install-dev

%:
	dh $@

## libglibutil 1.0.80+ds

=== debian/changelog ===
libglibutil (1.0.80+ds-1) unstable; urgency=medium

  * initial packaging. (Closes: #1126751)

 -- Seyed Mohamad Amin Modaresi <modaresisofthard@proton.me>  Sun, 01 Feb 2026 07:54:02 +0330

=== debian/control ===
Source: libglibutil
Section: libs
Maintainer: Seyed Mohamad Amin Modaresi <modaresisofthard@proton.me>
Build-Depends:
 debhelper-compat (= 13),
 libglib2.0-dev (>= 2.32)
Standards-Version: 4.7.3
Homepage: https://github.com/sailfishos/libglibutil
Vcs-Browser: https://salsa.debian.org/amin_modaresi/libglibutil
Vcs-Git: https://salsa.debian.org/amin_modaresi/libglibutil.git

Package: libglibutil1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library of glib utilities
 Library of glib utilities (shared files)

Package: libglibutil-dev
Section: libdevel
Architecture: any
Depends: libglibutil1 (= ${binary:Version}), ${misc:Depends}
Description: Library of glib utilities
 Library of glib utilities (developent files)

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,now

%:
	dh $@

=== debian/watch ===
Version: 5
Template: Github
Owner: sailfishos
Project: libglibutil
Dversion-Mangle: auto
Repacksuffix: +ds
